var wd = require('wd');
var fs = require('fs');

var b = wd.promiseRemote('http://localhost:9515');

var scroll = function() {
    var x = 0;
    (function _n() {
        window.scrollTo(0, x += 20), window.requestAnimationFrame(_n)
    })();
};

var config = {
    browserName: "chrome",
    version: 35,
    chromeOptions: {
        perfLoggingPrefs: {
            traceCategories: ",blink.console,devtools.timeline,disabled-by-default-devtools.timeline,benchmark"
        },
        args: ["--enable-gpu-benchmarking", "--enable-thread-composting"]
    },
    loggingPrefs: {
        performance: "ALL"
    }
};

var betterScroll = function() {
    window.chrome.gpuBenchmarking.smoothScrollBy(
        5000,
        function() {
            window.__scrollActionDone = true;
        },
        0,
        0,
        window.chrome.gpuBenchmarking.DEFAULT_INPUT,
        'down',
        800);
};

b.init(config).then(function() {
    return b.get('http://espn.com');
}).then(function() {
    return b.execute('(' + betterScroll.toString() + ')()')
}).then(function() {
    return b.waitFor({
        asserter: wd.asserters.jsCondition('(window.__scrollActionDone === true)', false),
        timeout: 1000 * 60 * 10,
        pollFreq: 2000
    });
}).then(function() {
    return b.log('performance');
}).then(function(res) {
    fs.writeFileSync('_perfLog.json', res.map(function(data) {
        return JSON.stringify(JSON.parse(data.message).message, 4);
    }));
}).fin(function() {
    return b.quit();
}).done()
